xquery version "3.0";

import module namespace xrx_example = "http://iu5.bmstu.ru/edu/xrx_example" at "module.xqm";

declare function local:NewData($newParam as xs:string, $IdParam as xs:string, $data_name as xs:string, $data_uri as xs:string) as node()
{
let 
    $id := 
    if($newParam='1')
    then (util:uuid())
    else ($IdParam)
return
    <db>
        <id>{$id}</id>
        <name>{$data_name}</name>
        <uri>{$data_uri}</uri>
    </db>
};


declare function local:SaveData($newParam as xs:string, $IdParam as xs:string, $data_name as xs:string, $data_uri as xs:string) as node()*
{
    let $data := local:NewData($newParam, $IdParam, $data_name, $data_uri)        
    return
        if($newParam='1')
        then
            (
                update insert $data 
                into doc($xrx_example:DataStorePath)//dbs
            )
        else
            (
                update replace doc($xrx_example:DataStorePath)//db[id=$IdParam] 
                with $data
            )
};

declare function local:DelData($IdParam as xs:string) as node()*
{
    let $data := doc($xrx_example:DataStorePath)//db[id=$IdParam]    
    return update delete $data
};


let 
  $newParam := xs:string(request:get-parameter("new","0")),
  $saveParam := xs:string(request:get-parameter("save","0")),
  $delParam := xs:string(request:get-parameter("del","0")),
  $IdParam := xs:string(request:get-parameter("id","0")),
  
  $data_name := xs:string(request:get-parameter("data_name","")),
  $data_uri := xs:string(request:get-parameter("data_uri",""))
  
return
(    
  xrx_example:login(),
  (
    if($saveParam = '1')
    then 
    (
      local:SaveData($newParam, $IdParam, $data_name, $data_uri)
    )
    else 
    (
        if($delParam = '1')
        then 
        (
          local:DelData($IdParam)
        )
        else ()    
    )
  ),
  response:redirect-to(xs:anyURI($xrx_example:IndexPath))
) 
